﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using CompanyData;

namespace CompanySLApp.Web
{
    // NOTE: If you change the class name "CompanyService" here, you must also update the reference to "CompanyService" in Web.config.
    public class CompanyService : ICompanyService
    {

        #region ICompanyService Members

        public List<CompanyData.Companies> GetCompanyList()
        {
            using (CompanyEntities context = new CompanyEntities())
            {
                return (from oneCompany in context.Companies
                        orderby oneCompany.CompanyName
                        select oneCompany).ToList();
            }
        }

        public CompanyData.Companies GetCompanyById(int companyID)
        {
            using (CompanyEntities context = new CompanyEntities())
            {
                return (from oneCompany in context.Companies.Include("Persons")
                        where oneCompany.CompanyId == companyID
                        select oneCompany).FirstOrDefault();
            }
        }

        public Companies Update(Companies company)
        {
            using (CompanyEntities context = new CompanyEntities())
            {

                if (company.CompanyId >= 0)
                {
                    // existing company
                    Companies existingCOmpany = new Companies();
                    existingCOmpany.CompanyId = company.CompanyId;
                    existingCOmpany.EntityKey = new System.Data.EntityKey("CompanyEntities.Companies", "CompanyId", company.CompanyId);
                    context.Attach(existingCOmpany);
                    existingCOmpany.Address = company.Address;
                    existingCOmpany.City = company.City;
                    existingCOmpany.CompanyName = company.CompanyName;
                    existingCOmpany.State = company.State;
                    existingCOmpany.Zip = company.Zip;
                    foreach (var item in company.Persons)
                    {
                        if (item.PersonId >= 0)
                        {
                            //existig person
                            Persons person = new Persons();
                            person.PersonId = item.PersonId;
                            person.EntityKey = new System.Data.EntityKey("CompanyEntities.Persons", "PersonId", person.PersonId);

                            context.Attach(person);
                            existingCOmpany.Persons.Attach(person);
                            person.FirstName = item.FirstName;
                            person.LastName = item.LastName;
                        }
                        else
                        {
                            //new person
                            Persons person = new Persons();
                            person.PersonId = item.PersonId;
                            person.FirstName = item.FirstName;
                            person.LastName = item.LastName;
                            context.AddToPersons(person);
                            existingCOmpany.Persons.Add(person);
                        }
                    }
                    var existingPersons = (from oneP in context.Persons
                                           where oneP.Companies.CompanyId == company.CompanyId
                                           select oneP.PersonId).ToList();
                    List<int> deletedPersons = new List<int>();
                    foreach (var item in existingPersons)
                    {
                        if ((from one in company.Persons
                             where one.PersonId == item
                             select one).Count() == 0)
                        {
                            deletedPersons.Add(item);
                        }
                    }
                    foreach (var item in deletedPersons)
                    {
                        //delete this person
                        Persons person = new Persons();
                        person.PersonId = item;
                        person.EntityKey = new System.Data.EntityKey("CompanyEntities.Persons", "PersonId", person.PersonId);

                        context.Attach(person);
                        existingCOmpany.Persons.Attach(person);
                        context.DeleteObject(person);
                    }
                    context.SaveChanges();
                    return existingCOmpany;
                }
                else
                {
                    //new company
                    context.AddToCompanies(company);
                    context.SaveChanges();
                    return company;
                }

                // round tripping to DB

                //List<Persons> updated = company.Persons.ToList();
                //company.Persons.Clear();

                //var existing = (from oneCompany in context.Companies.Include("Persons")
                //                where oneCompany.CompanyId == company.CompanyId
                //                select oneCompany).FirstOrDefault();
                //if (existing == null)
                //{
                //    context.AddToCompanies(company);
                //    foreach (var item in updated)
                //    {
                //        company.Persons.Add(item);
                //    }
                //}
                //else
                //{
                //    context.ApplyPropertyChanges("Companies", company);
                //    List<Persons> deleted = new List<Persons>();
                //    foreach (var item in existing.Persons)
                //    {
                //        var newPerson = (from one in updated
                //                         where one.PersonId == item.PersonId
                //                         select one).FirstOrDefault();
                //        if (newPerson != null)
                //        {
                //            context.ApplyPropertyChanges("Persons", newPerson);
                //        }
                //        else
                //        {
                //            deleted.Add(item);
                //        }
                //    }
                //    foreach (var item in deleted)
                //    {
                //        context.DeleteObject(item);
                //    }
                //    foreach (var item in updated)
                //    {
                //        var oldPerson = (from one in existing.Persons
                //                         where one.PersonId == item.PersonId
                //                         select one).FirstOrDefault();
                //        if (oldPerson == null)
                //        {
                //            existing.Persons.Add(item);
                //        }
                //    }
                //}


                //context.SaveChanges();
                //if (existing == null)
                //    return company;
                //else
                //    return existing;
            }
        }

        public void Delete(int companyID)
        {
            using (CompanyEntities context = new CompanyEntities())
            {
                Companies existingCOmpany = new Companies();
                existingCOmpany.CompanyId = companyID;
                existingCOmpany.EntityKey = new System.Data.EntityKey("CompanyEntities.Companies", "CompanyId", companyID);
                context.Attach(existingCOmpany);
                context.DeleteObject(existingCOmpany);


                // round - tripping
                //Companies company = (from oneCompany in context.Companies
                //                     where oneCompany.CompanyId == companyID
                //                     select oneCompany).FirstOrDefault();
                //context.DeleteObject(company);
                context.SaveChanges();
            }
        }

        #endregion
    }
}
